/*

Svar på deluppgift (a):



Svar på deluppgift (b):



*/

#include "wrap/synch.h"
#include "wrap/thread.h"
#include "wrap/atomics.h"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>

#define BUFFER_SIZE 32

struct idea_buffer {
	// Alla idéer i buffern. Tomma platser representeras av NULL.
	const char **ideas;

	// Antal platser i buffern.
	int size;

	// Antal platser som är fyllda i 'ideas'.
	int count;
};

// Initiera buffern.
void idea_init(struct idea_buffer *buffer) {
	buffer->size = 4;
	buffer->ideas = malloc(sizeof(const char *) * buffer->size);
	for (int i = 0; i < buffer->size; i++)
		buffer->ideas[i] = NULL;
	buffer->count = 0;
}

// Lägg till en ny idé på en ledig plats i buffern. Om buffern är
// full returneras 'false'.
bool idea_add(struct idea_buffer *buffer, const char *idea) {
	// Hitta en ledig plats.
	int found = buffer->size;
	for (int i = 0; i < buffer->size; i++) {
		if (buffer->ideas[i] == NULL) {
			found = i;
			break;
		}
	}

	// Fullt?
	if (found >= buffer->size)
		return false;

	// Sätt in i buffern.
	buffer->ideas[found] = idea;
	buffer->count++;

	return true;
}

// Ta bort ett element ur buffern. Elementen plockas ut i
// slumpmässig ordning. Om det inte finns några idéer ska
// funktionen vänta på att nya idéer läggs till.
const char *idea_get(struct idea_buffer *buffer) {
	while (buffer->count == 0)
		;
	buffer->count--;

	// Hitta ett element. Originalkoden slumpar fram ett element.
	// Det fungerar dock inte med "Run -> Look for errors", så
	// här börjar vi helt enkelt alltid från element 0.
	int pos = 0 % buffer->size;
	while (buffer->ideas[pos] == NULL) {
		pos = (pos + 1) % buffer->size;
	}

	const char *result = buffer->ideas[pos];
	buffer->ideas[pos] = NULL;

	return result;
}



/**
 * Huvudprogram. Endast för att visa hur vi kan köra
 * programmet. Vid rättning kommer eventuella modifikationer
 * härifrån och nedåt att ignoreras.
 */

void worker(struct idea_buffer *buffer) {
	idea_add(buffer, "Bagerier");
	idea_add(buffer, "Kortspel");
	idea_add(buffer, "Tarningar");
	idea_add(buffer, "Mazariner");
}

int main(void) {
	struct idea_buffer buffer;
	idea_init(&buffer);

	thread_new(&worker, &buffer);

	for (int i = 0; i < 4; i++) {
		printf("Idé: %s\n", idea_get(&buffer));
	}

	return 0;
}
